DCMTK: CID4020_PETRadionuclide Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Protected Types | Protected Member Functions | Static Protected Member Functions | Static Private Attributes | List of all members
CID4020_PETRadionuclide Class Reference

Implementation of DCMR Context Group: CID 4020 - PET Radionuclide. More...

Inheritance diagram for CID4020_PETRadionuclide:

## Public Types
enum | EnumType { _11_Carbon , _13_Nitrogen , _14_Oxygen , _15_Oxygen , _18_Fluorine , _22_Sodium , _38_Potassium , _43_Scandium , _44_Scandium , _45_Titanium , _51_Manganese , _52_Iron , _52_Manganese , _52m_Manganese , _60_Copper , _61_Copper , _62_Copper , _62_Zinc , _64_Copper , _66_Gallium , _68_Gallium , _68_Germanium , _70_Arsenic , _72_Arsenic , _73_Selenium , _75_Bromine , _76_Bromine , _77_Bromine , _82_Rubidium , _86_Yttrium , _89_Zirconium , _90_Niobium , _90_Yttrium , _94m_Technetium , _124_Iodine , _152_Terbium }
| types of PET radionuclide More...

## Public Member Functions
| CID4020_PETRadionuclide (const DSRCodedEntryValue &selectedValue=DSRCodedEntryValue())
| (default) constructor
| CID4020_PETRadionuclide (const EnumType selectedValue, const OFBool enhancedEncodingMode=OFFalse)
| constructor
virtual OFCondition | selectValue (const EnumType selectedValue, const OFBool enhancedEncodingMode=OFFalse)
| select a coded entry given by its type as the current value
virtual OFCondition | selectValue (const DSRCodedEntryValue &codedEntryValue, const OFBool check=OFTrue, const OFBool definedContextGroup=OFFalse)
| select a given coded entry as the current value
virtual OFCondition | findCodedEntry (const DSRCodedEntryValue &codedEntryValue) const
| search for a given coded entry in this context group.
Public Member Functions inherited from DSRContextGroup
| operator const DSRCodedEntryValue & () const
| conversion operator that returns the currently selected coded entry value (might be empty if none is selected)
virtual void | clear ()
| clear list of extended coded entries and forget about the currently selected coded entry
OFBool | isExtensible () const
| check whether context group is extensible
void | setExtensible (const OFBool mode=OFTrue)
| change mode specifying whether the context group is extensible or non-extensible
const OFString & | getIdentifier () const
| get context identifier
const OFString & | getMappingResource () const
| get mapping resource
const OFString & | getVersion () const
| get context group version (optional)
const OFString & | getUID () const
| get context group UID (optional)
virtual OFBool | hasSelectedValue () const
| check whether a coded entry is selected as the current value
const DSRCodedEntryValue & | getSelectedValue () const
| get currently selected coded entry value (optional)
virtual OFBool | hasCodedEntry (const DSRCodedEntryValue &codedEntryValue) const
| check whether a given coded entry is contained in this context group.
virtual OFBool | hasExtendedCodedEntries () const
| check whether this context group has any extended coded entries.
virtual OFCondition | addCodedEntry (const DSRCodedEntryValue &codedEntryValue)
| add a coded entry to this context group as an extension, i.e. as a non-standard code.
virtual OFCondition | lookupCodedEntry (DSRCodedEntryValue &codedEntryValue, const OFBool enhancedEncodingMode=OFFalse) const
| search for a given coded entry in this context group and, if found, replace its value with the one found in the context group.
virtual void | print (STD_NAMESPACE ostream &stream) const
| print contents of this context group, i.e. a general header, the currently selected coded entry value (if any) and all coded entries that are contained in this context group (both standard and extended ones).
virtual OFCondition | checkSelectedValue (const OFBool definedContextGroup=OFFalse) const
| check whether the currently selected coded entry is valid.

## Static Public Member Functions
static void | initialize ()
| initialize this context group explicitly.
static void | cleanup ()
| cleanup this context group, i.e. delete the internal list of standard coded entries.
static DSRCodedEntryValue | getCodedEntry (const EnumType value, const OFBool enhancedEncodingMode=OFFalse)
| map a given type to the associated coded entry

## Protected Types
typedef OFMap< EnumType, DSRBasicCodedEntry > | CodeList
| type used for storing and managing the coded entries

## Protected Member Functions
virtual void | printCodes (STD_NAMESPACE ostream &stream) const
| print details on coded entries that are contained in this context group.
virtual OFCondition | findCodedEntry (const DSRCodedEntryValue &searchForCodedEntry, DSRCodedEntryValue *foundCodedEntry, const OFBool enhancedEncodingMode=OFFalse) const
| search for a given coded entry in this context group
Protected Member Functions inherited from DSRContextGroup
| DSRContextGroup (const OFString &contextIdentifier, const OFString &mappingResource, const OFString &contextGroupVersion="", const OFString &contextGroupUID="", const DSRCodedEntryValue &selectedValue=DSRCodedEntryValue())
| constructor
virtual | ~DSRContextGroup ()
| destructor
virtual void | printHeader (STD_NAMESPACE ostream &stream) const
| print header with some general information on this context group
virtual OFCondition | checkCodedEntry (const DSRCodedEntryValue &codedEntryValue, const OFBool definedContextGroup) const
| check whether a given coded entry is valid.

## Static Protected Member Functions
static CodeList & | getCodes ()
| get list of standard coded entries that are managed by this context group.
static OFCondition | setEnhancedEncodingMode (DSRCodedEntryValue &codedEntryValue)
| set the "Enhanced Encoding Mode" for a given coded entry

## Static Private Attributes
static CodeList * | Codes
| pointer to internal code list (use a static variable for singleton pattern)

## Detailed Description

Implementation of DCMR Context Group: CID 4020 - PET Radionuclide.

(type: extensible, version: 20160119)

## Member Enumeration Documentation

## ◆ EnumType

enum CID4020_PETRadionuclide::EnumType

types of PET radionuclide

Enumerator
_11_Carbon | (40565003,SCT,"^11^Carbon")
_13_Nitrogen | (21576001,SCT,"^13^Nitrogen")
_14_Oxygen | (424875009,SCT,"^14^Oxygen")
_15_Oxygen | (129504001,SCT,"^15^Oxygen")
_18_Fluorine | (77004003,SCT,"^18^Fluorine")
_22_Sodium | (71633006,SCT,"^22^Sodium")
_38_Potassium | (423764008,SCT,"^38^Potassium")
_43_Scandium | (126605,DCM,"^43^Scandium")
_44_Scandium | (126600,DCM,"^44^Scandium")
_45_Titanium | (75696008,SCT,"^45^Titanium")
_51_Manganese | (126601,DCM,"^51^Manganese")
_52_Iron | (69089000,SCT,"^52^Iron")
_52_Manganese | (37225000,SCT,"^52^Manganese")
_52m_Manganese | (126607,DCM,"^52m^Manganese")
_60_Copper | (425364008,SCT,"^60^Copper")
_61_Copper | (71425003,SCT,"^61^Copper")
_62_Copper | (422934004,SCT,"^62^Copper")
_62_Zinc | (65054007,SCT,"^62^Zinc")
_64_Copper | (3932008,SCT,"^64^Copper")
_66_Gallium | (79477007,SCT,"^66^Gallium")
_68_Gallium | (35337001,SCT,"^68^Gallium")
_68_Germanium | (53315004,SCT,"^68^Germanium")
_70_Arsenic | (126602,DCM,"^70^Arsenic")
_72_Arsenic | (2705002,SCT,"^72^Arsenic")
_73_Selenium | (87437000,SCT,"^73^Selenium")
_75_Bromine | (17910003,SCT,"^75^Bromine")
_76_Bromine | (79523006,SCT,"^76^Bromine")
_77_Bromine | (86521004,SCT,"^77^Bromine")
_82_Rubidium | (79197006,SCT,"^82^Rubidium")
_86_Yttrium | (10738001,SCT,"^86^Yttrium")
_89_Zirconium | (63360001,SCT,"^89^Zirconium")
_90_Niobium | (126603,DCM,"^90^Niobium")
_90_Yttrium | (14691008,SCT,"^90^Yttrium")
_94m_Technetium | (424079002,SCT,"^94m^Technetium")
_124_Iodine | (40937006,SCT,"^124^Iodine")
_152_Terbium | (126606,DCM,"^152^Terbium")

## Constructor & Destructor Documentation

## ◆ CID4020_PETRadionuclide() [1/2]

CID4020_PETRadionuclide::CID4020_PETRadionuclide | ( | const DSRCodedEntryValue & | selectedValue = DSRCodedEntryValue() | ) |

(default) constructor

Parameters

  selectedValue | coded entry to be selected as the current value (optional). Should be a valid code according to the DICOM definitions for this context group, i.e. no checks are performed. Call DSRContextGroup::checkSelectedValue() if needed.

## ◆ CID4020_PETRadionuclide() [2/2]

CID4020_PETRadionuclide::CID4020_PETRadionuclide | ( | const EnumType | selectedValue,
|  | const OFBool | enhancedEncodingMode = OFFalse )

constructor

Parameters

  selectedValue | type mapped to a coded entry that is selected as the current value
  enhancedEncodingMode | set enhanced encoding mode for coded entry (if enabled)

## Member Function Documentation

## ◆ cleanup()

static void CID4020_PETRadionuclide::cleanup | ( |  | ) |
| static

cleanup this context group, i.e. delete the internal list of standard coded entries.

Usually, there is no need to call this method, but it might be useful in order to explicitly free the associated memory, e.g. when checking for memory leaks. The list will be recreated automatically when needed (or when initialize() is called).

## ◆ findCodedEntry() [1/2]

virtual OFCondition DSRContextGroup::findCodedEntry | ( | const DSRCodedEntryValue & | codedEntryValue | ) | const
| virtual

search for a given coded entry in this context group.

If found, the type of the entry (standard or extension) is returned:

- SR_EC_CodedEntryInStandardContextGroup
- SR_EC_CodedEntryIsExtensionOfContextGroup

Parameters

  codedEntryValue | coded entry to be searched for

Returns
  result of the search process, SR_EC_CodedEntryNotInContextGroup if coded entry could not be found. Use OFCondition::good() or OFCondition::bad() if not interested in the type of the entry.

Reimplemented from DSRContextGroup.

## ◆ findCodedEntry() [2/2]

virtual OFCondition CID4020_PETRadionuclide::findCodedEntry | ( | const DSRCodedEntryValue & | searchForCodedEntry,
|  | DSRCodedEntryValue * | foundCodedEntry,
|  | const OFBool | enhancedEncodingMode = OFFalse ) const
| protectedvirtual

search for a given coded entry in this context group

Parameters

  searchForCodedEntry | coded entry to be searched for
  foundCodedEntry | pointer to variable that will store the coded entry (if found and pointer is not NULL)
  enhancedEncodingMode | set enhanced encoding mode for coded entry (if enabled)

Returns
  result of the search process, also defines the type of the entry

Reimplemented from DSRContextGroup.

## ◆ getCodedEntry()

static DSRCodedEntryValue CID4020_PETRadionuclide::getCodedEntry | ( | const EnumType | value,
|  | const OFBool | enhancedEncodingMode = OFFalse )
| static

map a given type to the associated coded entry

Parameters

  value | type that should be mapped to a coded entry
  enhancedEncodingMode | set enhanced encoding mode for coded entry (if enabled)

Returns
  coded entry that is associated with the given type

References DSRContextGroup::findCodedEntry(), and DSRContextGroup::selectValue().

## ◆ getCodes()

static CodeList & CID4020_PETRadionuclide::getCodes | ( |  | ) |
| staticprotected

get list of standard coded entries that are managed by this context group.

Internally, the singleton pattern is used, so the list is initialized only once. Please note that this function is not thread-safe. Therefore, the initialize() function can be called before any instance of this class is actually used.

Returns
  reference to list of coded entries managed by this context group

## ◆ initialize()

static void CID4020_PETRadionuclide::initialize | ( |  | ) |
| static

initialize this context group explicitly.

Internally, the list of standard coded entries is created and initialized by calling getCodes().

Note
  This function can be called multiple times but in case of multi-threaded applications should be called at least once before any instance of this class is actually used. For single-threaded applications, there is no need to call it since the initialization is done implicitly.

## ◆ printCodes()

virtual void CID4020_PETRadionuclide::printCodes | ( | STD_NAMESPACE ostream & | stream | ) | const
| protectedvirtual

print details on coded entries that are contained in this context group.

See DSRCodedEntryValue::print() for details of the coded entry output.

Parameters

  stream | stream to which the output should be printed

Reimplemented from DSRContextGroup.

## ◆ selectValue() [1/2]

virtual OFCondition DSRContextGroup::selectValue | ( | const DSRCodedEntryValue & | codedEntryValue,
|  | const OFBool | check = OFTrue,
|  | const OFBool | definedContextGroup = OFFalse )
| virtual

select a given coded entry as the current value

Parameters

  codedEntryValue | coded entry to be selected as the current value
  check | if enabled, check 'codedEntryValue' for validity and appropriateness before selecting it as the current value. See checkSelectedValue() for details.
  definedContextGroup | flag indicating whether this context group is used as a baseline (default) or defined context group. The first means that the list of coded entries in this context group is just a suggestion. The latter means that one of the coded entries should be used.

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DSRContextGroup.

## ◆ selectValue() [2/2]

virtual OFCondition CID4020_PETRadionuclide::selectValue | ( | const EnumType | selectedValue,
|  | const OFBool | enhancedEncodingMode = OFFalse )
| virtual

select a coded entry given by its type as the current value

Parameters

  selectedValue | type mapped to a coded entry that is selected as the current value
  enhancedEncodingMode | set enhanced encoding mode for coded entry (if enabled)

Returns
  status, EC_Normal if successful, an error code otherwise

## ◆ setEnhancedEncodingMode()

static OFCondition CID4020_PETRadionuclide::setEnhancedEncodingMode | ( | DSRCodedEntryValue & | codedEntryValue | ) |
| staticprotected

set the "Enhanced Encoding Mode" for a given coded entry

Parameters

  codedEntryValue | coded entry for which the enhanced encoding mode is set

Returns
  status, EC_Normal if successful, an error code otherwise

The documentation for this class was generated from the following file:

- dcmsr/include/dcmtk/dcmsr/cmr/cid4020.h

Generated on Sat Mar 1 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2